@echo off

set first=1
set folderCount=0
set fileCount=0
set outfile=Merged.tmp.mp3
set outfileFinal=Merged.mp3
set mergetemp=merge-folder-temp.tmp
set mergetemp2=merge-folder-temp-recoded.tmp
set pattern=*.mp3
set handledExtension=audiobookTemp

if exist %outfileFinal% (
  echo %outfileFinal% already exists!
  goto ERROR
)

rem ** check how many MP3 files can be found
for /R %%f in (%pattern%) do (
  call :foundFile %%f
)
echo %fileCount% mp3 files found.

rem ** handle files folder by folder
for /D /R %%f in (*.*) do (
  call :doDir1 "%%f" "%%~nf"
)

rem ** last phase: encode the whole file again to make it work properly
echo Finalizing the target file..
call :recodeMP3 %outfile% %outfileFinal% Finalizing
if errorlevel 1 goto ERROR

del %outfile% > nul

rem ** outfile is now completed!
pause
goto :END

:foundFile
set /A fileCount=%fileCount%+1
goto :END

:doDir1
set fileDir="%~1"
set folderName="%~2"
if exist %fileDir%\%pattern% goto yesfiles
goto nofiles

:yesfiles
rem ** MP3 files found from the subfolder
echo Merging files from %folderName%..
set /A folderCount=%folderCount%+1
rem ** copy all MP3 files from the subfolder to a single temp file
for %%f in (%fileDir%\%pattern%) do (
rem call :recodeMP3 "%%f" "%%f.%handledExtension%" "%%~nf"
)
if errorlevel 1 goto ERROR
rem ** copy recoded files to a single temp file
rem echo Copying files from folder..
copy /B %fileDir%\%pattern% %mergetemp% > nul
rem copy /B %fileDir%\*.%handledExtension% %mergetemp% > nul
if errorlevel 1 goto ERROR
rem del /Q %fileDir%\*.%handledExtension% > nul
rem ** merge the folder temp file to the target file

if "%first%"=="1" (
  rem ** initialize empty output file **
  copy /Y NUL %outfile% > nul
  set srcfiles=%filedir%
  set first=
)

copy /B %outfile%+%mergetemp% %outfile% > nul
if errorlevel 1 goto ERROR
del %mergetemp%
if errorlevel 1 goto ERROR
:skip1
goto END

:nofiles
goto END

:recodeMP3
rem ** encode the MP3 with suitable bitrate
set source=%~1
set target=%~2
set filename=%~3
rem ** VBR 32-128kbps
echo  Encoding %filename% 
lame %1 %2 -S --quiet -V 9 -b 32 -B 128
if errorlevel 1 goto ERROR
goto END

:noFilesError
echo No MP3 files found
goto ERROR

:ERROR
echo Error %ERRORLEVEL%
pause

:END